import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Hero here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hero extends MovingActor {
    private static final int deltaX = 5;
    private static final int deltaY = 5;
    private static final int thresholdX = 50;
    private static final int thresholdY = 50;
    /**
     * Act - do whatever the Hero wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() {
        if (Greenfoot.isKeyDown("up")) {
            move(0, -deltaY);
        }
        if (Greenfoot.isKeyDown("down")) {
            move(0, deltaY);
        }
        if (Greenfoot.isKeyDown("left")) {
            move(-deltaX, 0);
        }
        if (Greenfoot.isKeyDown("right")) {
            move(deltaX, 0);
        }
    }
    
    public void move(int dx, int dy) {
        ScrollingWorld myWorld = (ScrollingWorld)getWorld();
        int nx = getX() + dx;
        int ny = getY() + dy;
        if (myWorld.getObjectsAt(nx, ny, Rock.class).size() == 0) {
            setLocation(nx, ny);
            if (  Math.abs(nx - myWorld.getWidth()/2) > thresholdX
               || Math.abs(ny - myWorld.getHeight()/2) > thresholdY
               ) {
                   myWorld.scroll(dx, dy);
            }
        }
    }
}
