import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ScrollingWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ScrollingWorld extends World {

    /**
     * Constructor for objects of class ScrollingWorld.
     * 
     */
    public ScrollingWorld() {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(800, 600, 1, false);
        GreenfootImage img = new AnchoredStuff().getImage();
        int stepy = img.getHeight();
        int stepx = img.getWidth();
        for (int x = stepx; x < getWidth(); x += stepx) {
            addObject(new AnchoredStuff(), x, stepy);
            addObject(new AnchoredStuff(), x, getHeight() - stepy);
        }
        for (int y = 2*stepy; y < getHeight() - 2*stepy; y += stepy) {
            addObject(new AnchoredStuff(), getWidth() - stepx, y);
            addObject(new AnchoredStuff(), stepx, y);
        }
        for (int i = 0; i < 6; i++) {
            addObject(new Rock(),
                      2*stepx + Greenfoot.getRandomNumber(getWidth() - 4*stepx),
                      2*stepy + Greenfoot.getRandomNumber(getHeight() - 4*stepy)
            );
        }
        addObject(new Hero(), getWidth()/2, getHeight()/2);
    }
    
    public void scroll(int dx, int dy) {
        for (Object o : this.getObjects(MovingActor.class)) {
            Actor a = (Actor)o;
            a.setLocation(a.getX() - dx, a.getY() - dy);
        }
    }

}
